package org.eclipse.tptp.chat.data;

import java.util.Collections;
import java.util.Date;
import java.util.Iterator;
import java.util.Vector;

import org.eclipse.tptp.chat.config.ChatConfig;

public class Room {

	private String name;

	private String description;

	private Vector users = new Vector();

	private Vector messages = new Vector();

	public Room() {

	}

	public Room(String inName) {
		name = inName;
	}

	public String getName() {

		return name;

	}

	public void setName(String inName) {

		name = inName;

	}

	public Vector getUserList() {
		return users;
	}

	public void addUser(User inUser) {

		boolean userAlreadyInRoom = false;
		for (Iterator it = users.iterator(); it.hasNext();) {
			User user = (User) it.next();
			if (user.getUsername().equalsIgnoreCase(inUser.getUsername())) {
				userAlreadyInRoom = true;
			}
		}
		if (!userAlreadyInRoom) {
			users.add(inUser);
			Collections.sort(users);
		}

	}

	public void removeUser(User inUser) {
		String usernameToRemove = inUser.getUsername();
		int i = 0;
		int indexToRemove = -1;
		for (Iterator it = users.iterator(); it.hasNext();) {
			User user = (User) it.next();
			if (user.getUsername().equalsIgnoreCase(usernameToRemove)) {
				indexToRemove = i;
			}
			i++;
		}
		if (indexToRemove != -1) {
			users.remove(indexToRemove);
		}

	}

	public Vector getMessages(Date inDateTime) {

		Vector al = new Vector();
		for (Iterator it = messages.iterator(); it.hasNext();) {
			Message message = (Message) it.next();
			if (message.getPostedDateTime().after(inDateTime)) {
				al.add(message);
			}
		}
		return al;

	}

	public void postMessage(Message inMessage) {

		if (messages.size() > ChatConfig.getMaxNumberofMessages()) {
			messages.clear();
		}
		messages.add(inMessage);

	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

}
