package org.eclipse.tptp.chat.filter;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

public class SessionFilter implements Filter {

	public static final String LOGGED_IN_FLAG = "isLoggedIn";

	public void destroy() {
		// TODO Auto-generated method stub

	}

	public void doFilter(ServletRequest request, ServletResponse response,
			FilterChain filterChain) throws IOException, ServletException {
		String path = (((HttpServletRequest) request).getServletPath())
				.toLowerCase();
		if (path.indexOf("index") == -1 && path.indexOf("login") == -1
				&& path.indexOf("logout") == -1 && path.indexOf("css") == -1
				&& path.indexOf("gif") == -1) {
			HttpSession session = ((HttpServletRequest) request).getSession();
			String isLoggedIn = (String) session.getAttribute(LOGGED_IN_FLAG);
			if (isLoggedIn == null) {
				request.getRequestDispatcher("/login.jsp").forward(request,
						response);
				return;
			} else {
				filterChain.doFilter(request, response);
			}
		} else {
			// Requested path is one of the ones we need to ignore, so request
			// can
			// continue as usual, we don't care yet if the user is logged in or
			// not.
			filterChain.doFilter(request, response);
		}

	}

	public void init(FilterConfig arg0) throws ServletException {
		// TODO Auto-generated method stub

	}

}
