package org.eclipse.tptp.chat.servlet;

import java.io.IOException;
import java.util.Date;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.eclipse.tptp.chat.dao.ChatDAO;
import org.eclipse.tptp.chat.data.User;
import org.eclipse.tptp.chat.filter.SessionFilter;

public class LoginServlet extends HttpServlet {
	
	private String contextPath = "";
	
	public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		contextPath = request.getContextPath();
		response.sendRedirect(contextPath + "/login.jsp");		
	}
	
	public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		HttpSession session = request.getSession();
		
		contextPath = request.getContextPath();		
		String username = request.getParameter("username");
		username = username.trim().toLowerCase();
		
		String password = request.getParameter("password");
		password = password.trim().toLowerCase();
		
		if (session != null &&
		        session.getAttribute(SessionFilter.LOGGED_IN_FLAG) != null) {
			
			if (session.getAttribute("user") == null) {
				User user = new User(username);
				user.setLastRequest(new Date());
				session.setAttribute("user", user);
			}
			//response.sendRedirect(contextPath + "/listrooms.jsp");
	        RequestDispatcher dispatcher = 
				request.getRequestDispatcher("chatroom");
	        dispatcher.forward(request, response);
		} else {
			if (username == null || username.equalsIgnoreCase("")) {
				// send error back
				response.sendRedirect(contextPath + "/login.jsp?ic=t");
			} else {
				if (ChatDAO.getInstance().isUsernameInUse(username)) {
					response.sendRedirect(contextPath + "/login.jsp?ic=t");
				} else {
					User user = new User(username);
					user.setLastRequest(new Date());
			        session.setAttribute("user", user);
			        session.setAttribute(SessionFilter.LOGGED_IN_FLAG, "yes");
			        ChatDAO.getInstance().logUserIn(user);
			        //response.sendRedirect(contextPath + "/listrooms.jsp");
			        RequestDispatcher dispatcher = 
						request.getRequestDispatcher("chatroom");
			        dispatcher.forward(request, response);
				}
			}
		}
	}


}
