package org.eclipse.tptp.chat.servlet;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Iterator;
import java.util.Vector;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.lang.StringEscapeUtils;
import org.eclipse.tptp.chat.dao.ChatDAO;
import org.eclipse.tptp.chat.data.Message;
import org.eclipse.tptp.chat.data.User;

public class LookUpMessagesServlet extends HttpServlet {
	public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		this.doPost(request, response);	
	}

	public void doPost(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
		HttpSession session = request.getSession();

		User user = (User) session.getAttribute("user");
		user.setLastRequest(new Date());
		session.setAttribute("user", user);

		String roomName = (String) session.getAttribute("roomName");
		Date lastDateTime = (Date) session.getAttribute("lastDateTime");

		if (lastDateTime == null) {
			lastDateTime = new Date();
		}

		ChatDAO dao = ChatDAO.getInstance();
		Vector messages = dao.getMessages(roomName, lastDateTime);

		StringBuffer xmlOut = new StringBuffer(4096);
		xmlOut.append("<messages>");
		for (Iterator it = messages.iterator(); it.hasNext();) {
			Message message = (Message) it.next();
			xmlOut.append("<message>");
			xmlOut.append("<postedBy>"
					+ StringEscapeUtils.escapeXml(message.getPostedBy()
							.getUsername()) + "</postedBy>");
			xmlOut.append("<postedDateTime>"
					+ new SimpleDateFormat()
							.format(message.getPostedDateTime())
					+ "</postedDateTime>");
			xmlOut.append("<msgText>"
					+ StringEscapeUtils.escapeXml(message.getText())
					+ "</msgText>");
			xmlOut.append("</message>");
			lastDateTime = message.getPostedDateTime();
		}
		xmlOut.append("</messages>");

		session.setAttribute("lastDateTime", lastDateTime);

		response.setContentType("text/xml");
		PrintWriter out = response.getWriter();
		out.println(xmlOut.toString());
		out.flush();
	}

}
