package org.eclipse.tptp.chat.servlet;

import java.io.IOException;
import java.util.Date;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.eclipse.tptp.chat.dao.ChatDAO;
import org.eclipse.tptp.chat.data.Message;
import org.eclipse.tptp.chat.data.User;

public class MessageServlet extends HttpServlet {
	public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		this.doPost(request, response);	
	}

	public void doPost(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
		HttpSession session = request.getSession();
	      User user = (User)session.getAttribute("user");
	      user.setLastRequest(new Date());
	      session.setAttribute("user", user);
	      String username = user.getUsername();
	      String roomName = (String)session.getAttribute("roomName");
	      String msgText = request.getParameter("msgText");
	      
	      Message message = new Message();
	      message.setPostedBy(user);
	      message.setPostedDateTime(new Date());
	      message.setText(msgText);
	      ChatDAO dao = ChatDAO.getInstance();
	      dao.postMessage(roomName, message);
	}

}
