package org.eclipse.tptp.chat.servlet;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Date;
import java.util.Iterator;
import java.util.LinkedHashMap;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.lang.StringEscapeUtils;
import org.eclipse.tptp.chat.dao.ChatDAO;
import org.eclipse.tptp.chat.data.User;

public class RoomUpdateStatsServlet extends HttpServlet {

	public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		this.doPost(request, response);	
	}
	
	public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		HttpSession session = request.getSession();
		
		User user = (User)session.getAttribute("user");
	    user.setLastRequest(new Date());
	    session.setAttribute("user", user);
	    
	    ChatDAO     dao      = ChatDAO.getInstance();
	    LinkedHashMap   roomList = dao.getRoomUserCounts();
	    
	    StringBuffer xmlOut = new StringBuffer(1024);
		xmlOut.append("<rooms>");
		for (Iterator it = roomList.keySet().iterator(); it.hasNext();) {
			String roomName = (String) it.next();
			Integer userCount = (Integer) roomList.get(roomName);
			xmlOut.append("<room name=\""
					+ StringEscapeUtils.escapeXml(roomName) + "\" "
					+ "users=\"" + userCount + "\"/>");
		}
		xmlOut.append("</rooms>");
		
	    response.setContentType("text/xml");
		PrintWriter out = response.getWriter();
		out.println(xmlOut.toString());
		out.flush();
	}
}
